/*
DXWnd/dxhook.cpp
DirectX Hook Module Core
Copyright(C) SFB7

2004/07/03 v1.02
*/
#define _WIN32_WINNT 0x0400
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <ddraw.h>
#include <d3d9.h>
#include <dinput.h>
#include "dxwnd.h"

typedef int (WINAPI *GetDeviceCaps_Type)(HDC, int);
typedef BOOL (WINAPI *GetCursorPos_Type)(LPPOINT);
void *SetHook(void *, void *);
typedef HRESULT (WINAPI *DirectDrawCreate_Type)(GUID *, LPDIRECTDRAW *, IUnknown *);
typedef HRESULT (WINAPI *DirectDrawCreateEx_Type)(GUID *, LPDIRECTDRAW *, REFIID, IUnknown *);
typedef void* (WINAPI *Direct3DCreate8_Type)(UINT);
typedef void* (WINAPI *Direct3DCreate9_Type)(UINT);
typedef HRESULT (WINAPI *QueryInterface_Type)(void *, REFIID, LPVOID *);
typedef HRESULT (WINAPI *CreateSurface_Type)(LPDIRECTDRAW, DDSURFACEDESC2 *, LPDIRECTDRAWSURFACE *, void *);
typedef HRESULT (WINAPI *SetCooperativeLevel_Type)(void *, HWND, DWORD);
typedef HRESULT (WINAPI *GetAttachedSurface_Type)(void *, DDSCAPS *, LPDIRECTDRAWSURFACE *);
typedef HRESULT (WINAPI *CreateDevice_Type)(void *, UINT, D3DDEVTYPE, HWND, DWORD, void *, void **);
typedef HRESULT (WINAPI *SetDisplayMode_Type)(LPDIRECTDRAW, DWORD, DWORD, DWORD, DWORD, DWORD);
typedef HRESULT (WINAPI *SetDisplayMode1_Type)(LPDIRECTDRAW, DWORD, DWORD, DWORD);
typedef HRESULT (WINAPI *CreatePalette_Type)(LPDIRECTDRAW, DWORD, LPPALETTEENTRY, LPDIRECTDRAWPALETTE *, IUnknown *);
typedef HRESULT (WINAPI *Blt_Type)(LPDIRECTDRAWSURFACE, LPRECT, LPDIRECTDRAWSURFACE, LPRECT, DWORD, LPDDBLTFX);
typedef HRESULT (WINAPI *SetPalette_Type)(LPDIRECTDRAWSURFACE, LPDIRECTDRAWPALETTE);
typedef HRESULT (WINAPI *GetPalette_Type)(LPDIRECTDRAWSURFACE, LPDIRECTDRAWPALETTE *);
typedef HRESULT (WINAPI *SetEntries_Type)(LPDIRECTDRAWPALETTE, DWORD, DWORD, DWORD, LPPALETTEENTRY);
typedef HRESULT (WINAPI *GetDisplayMode_Type)(LPDIRECTDRAW, LPDDSURFACEDESC);
typedef HRESULT (WINAPI *DirectInputCreate_Type)(HINSTANCE, DWORD, LPDIRECTINPUT *, LPUNKNOWN);
typedef HRESULT (WINAPI *DirectInputCreateEx_Type)(HINSTANCE, DWORD, REFIID, LPVOID *, LPUNKNOWN);
typedef HRESULT (WINAPI *DICreateDevice_Type)(LPDIRECTINPUT, REFGUID, LPDIRECTINPUTDEVICE *, LPUNKNOWN);
typedef HRESULT (WINAPI *DICreateDeviceEx_Type)(LPDIRECTINPUT, REFGUID, REFIID, LPVOID *, LPUNKNOWN);
typedef HRESULT (WINAPI *GetDeviceState_Type)(LPDIRECTINPUTDEVICE, DWORD, LPDIMOUSESTATE);
typedef HRESULT (WINAPI *DISetCooperativeLevel_Type)(LPDIRECTINPUTDEVICE, HWND, DWORD);
typedef HRESULT (WINAPI *SetDataFormat_Type)(LPDIRECTINPUTDEVICE, LPCDIDATAFORMAT);

void OutTrace(const char *, ...);
void *HookAPI(const char *, const char *, void *);
int WINAPI extGetDeviceCaps(HDC, int);
BOOL WINAPI extGetCursorPos(LPPOINT);
HRESULT WINAPI extDirectDrawCreate(GUID FAR *, LPDIRECTDRAW FAR *, IUnknown FAR *);
HRESULT WINAPI extDirectDrawCreateEx(GUID FAR *, LPDIRECTDRAW FAR *, REFIID, IUnknown FAR *);
void* WINAPI extDirect3DCreate8(UINT);
void* WINAPI extDirect3DCreate9(UINT);
HRESULT WINAPI extQueryInterfaceD(void *, REFIID, LPVOID *);
HRESULT WINAPI extQueryInterfaceS(void *, REFIID, LPVOID *);
HRESULT WINAPI extSetDisplayMode(LPDIRECTDRAW, DWORD, DWORD, DWORD, DWORD, DWORD);
HRESULT WINAPI extSetDisplayMode1(LPDIRECTDRAW, DWORD, DWORD, DWORD);
HRESULT WINAPI extCreateSurface(LPDIRECTDRAW, DDSURFACEDESC2 *, LPDIRECTDRAWSURFACE *, void *);
HRESULT WINAPI extSetCooperativeLevel(void *, HWND, DWORD);
HRESULT WINAPI extGetAttachedSurface(void *, DDSCAPS *, LPDIRECTDRAWSURFACE *);
HRESULT WINAPI extFlip(LPDIRECTDRAWSURFACE, LPDIRECTDRAWSURFACE, DWORD);
HRESULT WINAPI extCreateDevice(void *, UINT, D3DDEVTYPE, HWND, DWORD, D3DPRESENT_PARAMETERS *, void **);
HRESULT WINAPI extBltFast(LPDIRECTDRAWSURFACE, DWORD, DWORD, LPDIRECTDRAWSURFACE, LPRECT, DWORD);
HRESULT WINAPI extCreatePalette(LPDIRECTDRAW, DWORD, LPPALETTEENTRY, LPDIRECTDRAWPALETTE *, IUnknown *);
HRESULT WINAPI extSetEntries(LPDIRECTDRAWPALETTE, DWORD, DWORD, DWORD, LPPALETTEENTRY);
HRESULT WINAPI extBlt(LPDIRECTDRAWSURFACE, LPRECT, LPDIRECTDRAWSURFACE, LPRECT, DWORD, LPDDBLTFX);
HRESULT WINAPI extGetPalette(LPDIRECTDRAWSURFACE, LPDIRECTDRAWPALETTE *);
HRESULT WINAPI extSetPalette(LPDIRECTDRAWSURFACE, LPDIRECTDRAWPALETTE);
HRESULT WINAPI extGetDisplayMode(LPDIRECTDRAW, LPDDSURFACEDESC);
HRESULT WINAPI extDirectInputCreate(HINSTANCE, DWORD, LPDIRECTINPUT *, LPUNKNOWN);
HRESULT WINAPI extDirectInputCreateEx(HINSTANCE, DWORD, REFIID, LPVOID *, LPUNKNOWN);
HRESULT WINAPI extDICreateDevice(LPDIRECTINPUT, REFGUID, LPDIRECTINPUTDEVICE *, LPUNKNOWN);
HRESULT WINAPI extDICreateDeviceEx(LPDIRECTINPUT, REFGUID, REFIID, LPVOID *, LPUNKNOWN);
HRESULT WINAPI extGetDeviceState(LPDIRECTINPUTDEVICE, DWORD, LPDIMOUSESTATE);
HRESULT WINAPI extDISetCooperativeLevel(LPDIRECTINPUTDEVICE, HWND, DWORD);
HRESULT WINAPI extSetDataFormat(LPDIRECTINPUTDEVICE, LPCDIDATAFORMAT);
HRESULT WINAPI extQueryInterfaceI(void *, REFIID, LPVOID *);

HWND hWnd = 0;
DWORD dwWidth = 0;
DWORD dwHeight;
DWORD dwFlags;
DWORD dwVersion;
BOOL bDInputAbs = 0;

DirectDrawCreate_Type pDirectDrawCreate;
DirectDrawCreateEx_Type pDirectDrawCreateEx;
Direct3DCreate8_Type pDirect3DCreate8;
Direct3DCreate9_Type pDirect3DCreate9;
QueryInterface_Type pQueryInterfaceD;
QueryInterface_Type pQueryInterfaceS;
CreateSurface_Type pCreateSurface;
CreateSurface_Type pCreateSurfaceOld;
SetCooperativeLevel_Type pSetCooperativeLevel;
GetAttachedSurface_Type pGetAttachedSurface;
CreateDevice_Type pCreateDevice;
SetDisplayMode_Type pSetDisplayMode;
SetDisplayMode1_Type pSetDisplayMode1;
CreatePalette_Type pCreatePalette;
Blt_Type pBlt;
GetPalette_Type pGetPalette;
SetPalette_Type pSetPalette;
SetEntries_Type pSetEntries;
GetDisplayMode_Type pGetDisplayMode;
GetDeviceCaps_Type pGetDeviceCaps;
GetCursorPos_Type pGetCursorPos;
DirectInputCreate_Type pDirectInputCreate;
DirectInputCreateEx_Type pDirectInputCreateEx;
DICreateDevice_Type pDICreateDevice = 0;
DICreateDeviceEx_Type pDICreateDeviceEx = 0;
GetDeviceState_Type pGetDeviceState;
DISetCooperativeLevel_Type pDISetCooperativeLevel;
SetDataFormat_Type pSetDataFormat;
QueryInterface_Type pQueryInterfaceI;

WNDPROC pWindowProc = 0;

LPDIRECTDRAWSURFACE lpDDSBack, lpDDSPrim, lpDDSEmu_Prim, lpDDSEmu_Back;
LPDIRECTDRAWCLIPPER lpDDC;
LPDIRECTDRAWPALETTE lpDDP = 0;
DWORD PaletteEntries[256];

char Path[MAX_PATH];
void OutTrace(const char *format, ...)
{
	va_list al;
	int i;
	void *a[8];
	FILE *fp;

	if(!(dwFlags & OUTTRACE)) return;

	GetCurrentDirectory(MAX_PATH, Path);
	strcat(Path, "\\dxwnd.log");
	fp = fopen(Path, "a+");
	va_start(al, format);
	for(i = 0; i < 8;i ++) a[i] = va_arg(al, void *);
	fprintf(fp, format, a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7]);
	va_end(al);
	fclose(fp);
}

void *HookAPI(const char *module, const char *api, void *hookproc)
{
	int i;
	DWORD base;
	PIMAGE_NT_HEADERS pnth;
	PIMAGE_IMPORT_DESCRIPTOR pidesc;
	DWORD rva;
	PSTR impmodule;
	PIMAGE_THUNK_DATA ptaddr;
	PIMAGE_THUNK_DATA ptname;
	PIMAGE_IMPORT_BY_NAME piname;
	DWORD oldprotect;
	void *org;
	
	base = (DWORD)GetModuleHandle(0);
	if(!base) return 0;
	__try{
		pnth = PIMAGE_NT_HEADERS(PBYTE(base) + PIMAGE_DOS_HEADER(base)->e_lfanew);
		if(!pnth) return 0;
		rva = pnth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
		if(!rva) return 0;
		pidesc = (PIMAGE_IMPORT_DESCRIPTOR)(base + rva);
		while(1){
			if(!pidesc->FirstThunk) return 0;
			impmodule = (PSTR)(base + pidesc->Name);
			if(!lstrcmpi(module, impmodule)) break;
			pidesc ++;
		}
		ptaddr = (PIMAGE_THUNK_DATA)(base + (DWORD)pidesc->FirstThunk);
		ptname = (PIMAGE_THUNK_DATA)(base + (DWORD)pidesc->OriginalFirstThunk);
		for(i = 0; (ptaddr + i)->u1.Function; i ++);
		while(1){
			if(!ptaddr->u1.Function) return 0;
			if(!IMAGE_SNAP_BY_ORDINAL(ptname->u1.Ordinal)){
				piname = (PIMAGE_IMPORT_BY_NAME)(base + (DWORD)ptname->u1.AddressOfData);
				if(!lstrcmpi(api, (char *)piname->Name)) break;
			}
			ptaddr ++;
			ptname ++;
		}
		org = ptaddr->u1.Function;
			if(org == hookproc) return 0;
		if(!VirtualProtect(&ptaddr->u1.Function, 4, PAGE_EXECUTE_READWRITE, &oldprotect)) return 0;
		ptaddr->u1.Function = (DWORD *)hookproc;
		VirtualProtect(&ptaddr->u1.Function, 4, oldprotect, &oldprotect);
	 }
	__except(EXCEPTION_EXECUTE_HANDLER)
	{       
		OutTrace("%s:%s Hook Failed.\n", module, api);
		org = 0;
	}
	return org;
}

void *SetHook(void *target, void *hookproc)
{
	DWORD tmp, oldprot;
	
	tmp = *(DWORD *)target;
	if(tmp == (DWORD)hookproc) return 0;
	if(!VirtualProtect(target, 4, PAGE_READWRITE, &oldprot)) return 0;
	*(DWORD *)target = (DWORD)hookproc;
	VirtualProtect(target, 4, oldprot, &oldprot);
	return (void *)tmp;
}

LRESULT CALLBACK extWindowProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	POINT p;

	switch(message){
	case WM_ACTIVATE:
	case WM_NCACTIVATE:
		SetWindowPos(hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
		if(dwFlags & UNNOTIFY){
			DefWindowProc(hwnd, message, wparam, lparam);
			return false;
		}
		break;
	case WM_MOUSEMOVE:
	case WM_MOUSEWHEEL:
	case WM_LBUTTONDOWN:
	case WM_LBUTTONUP:
	case WM_LBUTTONDBLCLK:
	case WM_RBUTTONDOWN:
	case WM_RBUTTONUP:
	case WM_RBUTTONDBLCLK:
	case WM_MBUTTONDOWN:
	case WM_MBUTTONUP:
	case WM_MBUTTONDBLCLK:
		if(dwFlags & MODIFYMOUSE){
			p.x = LOWORD(lparam);
			p.y = HIWORD(lparam);
			ScreenToClient(hwnd, &p);
			if(p.x < 0) p.x = 0;
			if(p.x >= dwWidth) p.x = dwWidth - 1;
			if(p.y < 0) p.y = 0;
			if(p.y >= dwHeight) p.y = dwHeight - 1;
			lparam = MAKELPARAM(p.y, p.x);
		}
		break;
	}
	if(pWindowProc) return (*pWindowProc)(hwnd, message, wparam, lparam);
	return DefWindowProc(hwnd, message, wparam, lparam);
}

int WINAPI extGetDeviceCaps(HDC hdc, int nindex)
{
	int res;
	
	res = (*GetDeviceCaps)(hdc, nindex);
	OutTrace("GetDeviceCaps: hdc = %x index = %x res = %x\n",
		hdc, nindex, res);

	switch(nindex){
	case RASTERCAPS:
		if(dwFlags & EMULATEPAL) res |= RC_PALETTE;
		break;
	case BITSPIXEL:
	case COLORRES:
		if(dwFlags & EMULATEPAL) res = 8;
		break;
	case SIZEPALETTE:
		if(dwFlags & EMULATEPAL) res = 256;
		break;
	case NUMRESERVED:
		if(dwFlags & EMULATEPAL) res = 0;
		break;
	}
	return res;
}

BOOL WINAPI extGetCursorPos(LPPOINT lppoint)
{
	(*pGetCursorPos)(lppoint);
	OutTrace("GetCursorPos: x = %i y = %i\n", lppoint->x, lppoint->y);

	if(dwFlags & MODIFYMOUSE){
		ScreenToClient(hWnd, lppoint);
		if(lppoint->x < 0) lppoint->x = 0;
		if(lppoint->x >= dwWidth) lppoint->x = dwWidth - 1;
		if(lppoint->y < 0) lppoint->y = 0;
		if(lppoint->y >= dwHeight) lppoint->y = dwHeight - 1;
	}
	return 1;
}

HRESULT WINAPI extDirectDrawCreate(GUID FAR *lpguid,
	LPDIRECTDRAW FAR *lplpdd, IUnknown FAR *pu)
{
	HRESULT res;
	void *tmp;

	dwVersion = 1;
	res = (*pDirectDrawCreate)(lpguid, lplpdd, pu);
	if(res) return res;
	tmp = SetHook((void *)(**(DWORD **)lplpdd), extQueryInterfaceD);
	if(tmp) pQueryInterfaceD = (QueryInterface_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 84), extSetDisplayMode1);
	if(tmp) pSetDisplayMode1 = (SetDisplayMode1_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 24), extCreateSurface);
	if(tmp) pCreateSurface = (CreateSurface_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 80), extSetCooperativeLevel);
	if(tmp) pSetCooperativeLevel = (SetCooperativeLevel_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 20), extCreatePalette);
	if(tmp) pCreatePalette = (CreatePalette_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 48), extGetDisplayMode);
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 56), 0);
	if(tmp) pGetDisplayMode = (GetDisplayMode_Type)tmp;

	OutTrace("DirectDrawCreate: pCreateSurface = %x\n",
		pCreateSurface);

	return 0;
}

HRESULT WINAPI extDirectDrawCreateEx(GUID FAR *lpguid,
	LPDIRECTDRAW FAR *lplpdd, REFIID iid, IUnknown FAR *pu)
{
	HRESULT res;
	void *tmp;

	dwVersion = 7;
	res = (*pDirectDrawCreateEx)(lpguid, lplpdd, iid, pu);
	if(res) return res;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 84), extSetDisplayMode);
	if(tmp) pSetDisplayMode = (SetDisplayMode_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 24), extCreateSurface);
	if(tmp) pCreateSurface = (CreateSurface_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 80), extSetCooperativeLevel);
	if(tmp) pSetCooperativeLevel = (SetCooperativeLevel_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 20), extCreatePalette);
	if(tmp) pCreatePalette = (CreatePalette_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 48), extGetDisplayMode);
	if(tmp) pGetDisplayMode = (GetDisplayMode_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdd + 56), 0);

	OutTrace("DirectDrawCreateEx: REFIID = %x pCreateSurface = %x\n",
		iid.Data1, pCreateSurface);

	return 0;
}

void* WINAPI extDirect3DCreate8(UINT sdkversion)
{
	void *lpd3d;
	void *tmp;

	dwVersion = 8;
	lpd3d = (*pDirect3DCreate8)(sdkversion);
	if(!lpd3d) return 0;
	tmp = SetHook((void *)(*(DWORD *)lpd3d + 60), extCreateDevice);
	if(tmp) pCreateDevice = (CreateDevice_Type)tmp;

	OutTrace("Direct3DCreate8: SDKVERSION = %x pCreateDevice = %x\n",
		sdkversion, pCreateDevice);
	return lpd3d;
}

void* WINAPI extDirect3DCreate9(UINT sdkversion)
{
	void *lpd3d;
	void *tmp;

	dwVersion = 9;
	lpd3d = (*pDirect3DCreate9)(sdkversion);
	if(!lpd3d) return 0;
	tmp = SetHook((void *)(*(DWORD *)lpd3d + 64), extCreateDevice);
	if(tmp) pCreateDevice = (CreateDevice_Type)tmp;

	OutTrace("Direct3DCreate9: SDKVERSION = %x pCreateDevice = %x\n",
		sdkversion, pCreateDevice);

	return lpd3d;
}

HRESULT WINAPI extQueryInterfaceD(void *lpdd, REFIID riid, LPVOID *obp)
{
	HRESULT res;
	void *tmp;

	res = (*pQueryInterfaceD)(lpdd, riid, obp);

	if(res) return res;

	switch(riid.Data1){
	case 0x9c59509a:		//DirectDraw4
		dwVersion = 4;
	case 0xB3A6F3E0:		//DirectDraw2
		if(dwVersion != 4) dwVersion = 2;
		tmp = SetHook((void *)(**(DWORD **)obp + 84), extSetDisplayMode);
		if(tmp) pSetDisplayMode = (SetDisplayMode_Type)tmp;
		tmp = SetHook((void *)(**(DWORD **)obp + 24), extCreateSurface);
		if(tmp){
			pCreateSurfaceOld = pCreateSurface;
			pCreateSurface = (CreateSurface_Type)tmp;
		}
		tmp = SetHook((void *)(**(DWORD **)obp + 80), extSetCooperativeLevel);
		if(tmp) pSetCooperativeLevel = (SetCooperativeLevel_Type)tmp;
		tmp = SetHook((void *)(**(DWORD **)obp + 20), extCreatePalette);
		if(tmp) pCreatePalette = (CreatePalette_Type)tmp;
		tmp = SetHook((void *)(**(DWORD **)obp + 48), extGetDisplayMode);
		if(tmp) pGetDisplayMode = (GetDisplayMode_Type)tmp;
		break;
	}

	OutTrace("lpDD->QueryInterface: lpDD = %x REFIID = %x pCreateSurface = %x\n",
		lpdd, riid.Data1, pCreateSurface);

	return 0;
}

HRESULT WINAPI extQueryInterfaceS(void *lpdds, REFIID riid, LPVOID *obp)
{
	HRESULT res;
	void *tmp;

	res = (*pQueryInterfaceS)(lpdds, riid, obp);
	if(res) return res;
	switch(riid.Data1){
	case 0xDA044E00:		//DDSurface3
		dwVersion = 3;
		if(lpdds == lpDDSPrim){
			lpDDSPrim = (LPDIRECTDRAWSURFACE)*obp;
		}
		tmp = SetHook((void *)(**(DWORD **)obp + 48), extGetAttachedSurface);
		if(tmp) pGetAttachedSurface = (GetAttachedSurface_Type)tmp;
		SetHook((void *)(**(DWORD **)obp + 44), extFlip);
		tmp = SetHook((void *)(**(DWORD **)obp + 20), extBlt);
		if(tmp) pBlt = (Blt_Type)tmp;
		SetHook((void *)(**(DWORD **)obp + 28), extBltFast);
		tmp = SetHook((void *)(**(DWORD **)obp + 80), extGetPalette);
		if(tmp) pGetPalette = (GetPalette_Type)tmp;
		tmp = SetHook((void *)(**(DWORD **)obp + 124), extSetPalette);
		if(tmp) pSetPalette = (SetPalette_Type)tmp;
		break;
	}

	OutTrace("lpDDS->QueryInterface: lpdds = %x REFIID = %x\n",
		lpdds, riid.Data1);

	return 0;
}

void AdjustWindowFrame(void)
{
	RECT rect;
	POINT p = {0, 0};
	static BOOL check = 0;

	if(check) return;
	check = 1;
	rect.top = 0;
	rect.left = 0;
	rect.right = dwWidth - 1;
	rect.bottom = dwHeight - 1;
	AdjustWindowRect(&rect, WS_OVERLAPPEDWINDOW, FALSE);
	SetWindowLong(hWnd, GWL_STYLE, WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU |
		WS_MINIMIZEBOX | WS_MAXIMIZEBOX);
	SetWindowPos(hWnd, 0, 0, 0, rect.right - rect.left, rect.bottom - rect.top, 0);
	ShowWindow(hWnd, SW_SHOWNORMAL);
	pWindowProc = (WNDPROC)GetWindowLong(hWnd, GWL_WNDPROC);
	if(!((DWORD)pWindowProc & 0xff000000))
		(WNDPROC)SetWindowLong(hWnd, GWL_WNDPROC, (LONG)extWindowProc);
	if(dwFlags & HIDECURSOR) ShowCursor(0);
	if(dwFlags & CAPTURECURSOR){
		ClientToScreen(hWnd, &p);
		rect.left = p.x;
		rect.top = p.y;
		rect.right = p.x + dwWidth - 1;
		rect.bottom = p.y + dwHeight - 1;
		ClipCursor(&rect);
	}
	else ClipCursor(0);
	InvalidateRect(0, 0, TRUE);
}

HRESULT WINAPI extSetDisplayMode(LPDIRECTDRAW lpdd,
	DWORD dwwidth, DWORD dwheight, DWORD dwbpp, DWORD dwrefreshrate, DWORD dwflags)
{
	DDSURFACEDESC2 ddsd;
	HRESULT res = 0;

	OutTrace("SetDisplayMode: dwWidth = %i dwHeight = %i dwBPP = %i dwRefresh = %i dwFlags = %x\n",
		dwwidth, dwheight, dwbpp, dwrefreshrate, dwflags);

	dwWidth = dwwidth;
	dwHeight = dwheight;
	if(hWnd) AdjustWindowFrame();

	if(dwFlags & EMULATEPAL) dwbpp = 32;

	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = (dwVersion < 4) ? sizeof(DDSURFACEDESC) : sizeof(DDSURFACEDESC2);
	ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT | DDSD_REFRESHRATE;
	ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
	ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB;

	(*pGetDisplayMode)(lpdd, (LPDDSURFACEDESC)&ddsd);
	if(ddsd.ddpfPixelFormat.dwRGBBitCount != dwbpp)
		res = (*pSetDisplayMode)(lpdd, ddsd.dwWidth, ddsd.dwHeight, dwbpp, ddsd.dwRefreshRate, 0);
	
	return 0;
}

HRESULT WINAPI extSetDisplayMode1(LPDIRECTDRAW lpdd,
	DWORD dwwidth, DWORD dwheight, DWORD dwbpp)
{
	DDSURFACEDESC2 ddsd;
	HRESULT res = 0;

	OutTrace("SetDisplayMode1: dwWidth = %i dwHeight = %i dwBPP = %i\n",
		dwwidth, dwheight, dwbpp);

	dwWidth = dwwidth;
	dwHeight = dwheight;
	if(hWnd) AdjustWindowFrame();

	if(dwFlags & EMULATEPAL) dwbpp = 32;
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = (dwVersion < 4) ? sizeof(DDSURFACEDESC) : sizeof(DDSURFACEDESC2);
	ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
	ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
	ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB;
	(*pGetDisplayMode)(lpdd, (LPDDSURFACEDESC)&ddsd);
	if(ddsd.ddpfPixelFormat.dwRGBBitCount != dwbpp)
		res = (*pSetDisplayMode1)(lpdd, ddsd.dwWidth, ddsd.dwHeight, dwbpp);
	return res;
}

HRESULT WINAPI extGetDisplayMode(LPDIRECTDRAW lpdd, LPDDSURFACEDESC lpddsd)
{
	OutTrace("GetDisplayMode\n");

	(*pGetDisplayMode)(lpdd, lpddsd);
	lpddsd->dwWidth = dwWidth;
	lpddsd->dwHeight = dwHeight;
	if(dwFlags & EMULATEPAL){
		lpddsd->ddpfPixelFormat.dwFlags |= DDPF_PALETTEINDEXED8;
		lpddsd->ddpfPixelFormat.dwRGBBitCount = 8;
		lpddsd->ddsCaps.dwCaps |= DDSCAPS_PALETTE;
	}
	return 0;
}

HRESULT WINAPI extSetCooperativeLevel(void *lpdd, HWND hwnd, DWORD dwflags)
{
	hWnd = hwnd;

	OutTrace("SetCooperativeLevel: dwFlags = %x\n",
		dwflags);

	if(dwWidth) AdjustWindowFrame();
	return (*pSetCooperativeLevel)(lpdd, hwnd, DDSCL_NORMAL);
}

HRESULT WINAPI extCreateSurface(LPDIRECTDRAW lpdd, DDSURFACEDESC2 *lpddsd,
	LPDIRECTDRAWSURFACE *lplpdds, void *pu)
{
	void *tmp;
	HRESULT res;
	DDSURFACEDESC2 ddsd;

	OutTrace("CreateSurface: lpDD = %x Flags = %x Width = %i Height = %i Caps = %x",
		lpdd, lpddsd->dwFlags, lpddsd->dwWidth, lpddsd->dwHeight, lpddsd->ddsCaps.dwCaps);

	memcpy(&ddsd, lpddsd, lpddsd->dwSize);

	if(ddsd.dwFlags & DDSD_CAPS && ddsd.ddsCaps.dwCaps & DDSCAPS_PRIMARYSURFACE){

		if(dwFlags & EMULATEPAL){
			ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
			ddsd.ddsCaps.dwCaps = DDSCAPS_SYSTEMMEMORY | DDSCAPS_OFFSCREENPLAIN;
			ddsd.dwWidth = dwWidth;
			ddsd.dwHeight = dwHeight;
			ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
			ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB | DDPF_PALETTEINDEXED8;
			ddsd.ddpfPixelFormat.dwRGBBitCount = 8;
			(*pCreateSurface)(lpdd, &ddsd, lplpdds, 0);
			lpDDSPrim = *lplpdds;
			(*pCreateSurface)(lpdd, &ddsd, &lpDDSBack, 0);
			ddsd.dwFlags = DDSD_CAPS;
			ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
			(*pCreateSurface)(lpdd, &ddsd, &lpDDSEmu_Prim, 0);
			lpdd->CreateClipper(0, &lpDDC, NULL);
			lpDDC->SetHWnd(0, hWnd);
			lpDDSEmu_Prim->SetClipper(lpDDC);
			ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
			ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
			ddsd.dwWidth = dwWidth;
			ddsd.dwHeight = dwHeight;
			(*pCreateSurface)(lpdd, &ddsd, &lpDDSEmu_Back, 0);
		}
		else{
			ddsd.dwFlags &= ~(DDSD_WIDTH | DDSD_HEIGHT | DDSD_BACKBUFFERCOUNT |
				DDSD_REFRESHRATE | DDSD_PIXELFORMAT);
			ddsd.ddsCaps.dwCaps &= ~(DDSCAPS_FLIP | DDSCAPS_COMPLEX);
			res = (*pCreateSurface)(lpdd, &ddsd, lplpdds, pu);
			if(res) return res;
			lpDDSPrim = *lplpdds;
			lpdd->CreateClipper(0, &lpDDC, NULL);
			lpDDC->SetHWnd(0, hWnd);
			lpDDSPrim->SetClipper(lpDDC);

			ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
			ddsd.dwWidth = dwWidth;
			ddsd.dwHeight = dwHeight;
			ddsd.ddsCaps.dwCaps &= ~DDSCAPS_PRIMARYSURFACE;
			ddsd.ddsCaps.dwCaps |= DDSCAPS_OFFSCREENPLAIN;

			(*pCreateSurface)(lpdd, &ddsd, &lpDDSBack, 0);
		}
		tmp = SetHook((void *)(*(DWORD *)lpDDSPrim), extQueryInterfaceS);
		if(tmp) pQueryInterfaceS = (QueryInterface_Type)tmp;
		tmp = SetHook((void *)(*(DWORD *)lpDDSPrim + 48), extGetAttachedSurface);
		if(tmp) pGetAttachedSurface = (GetAttachedSurface_Type)tmp;
		SetHook((void *)(*(DWORD *)lpDDSPrim + 44), extFlip);
		tmp = SetHook((void *)(*(DWORD *)lpDDSPrim + 20), extBlt);
		if(tmp) pBlt = (Blt_Type)tmp;
		SetHook((void *)(*(DWORD *)lpDDSPrim + 28), extBltFast);
		tmp = SetHook((void *)(*(DWORD *)lpDDSPrim + 80), extGetPalette);
		if(tmp) pGetPalette = (GetPalette_Type)tmp;
		tmp = SetHook((void *)(*(DWORD *)lpDDSPrim + 124), extSetPalette);
		if(tmp) pSetPalette = (SetPalette_Type)tmp;
		
		OutTrace(" Primary Return %x\n", 0);
		return 0;
	}
	if(dwFlags & EMULATEPAL && !(ddsd.dwFlags & DDSD_PIXELFORMAT)){
		ddsd.ddsCaps.dwCaps &= ~DDSCAPS_VIDEOMEMORY;
		ddsd.ddsCaps.dwCaps |= DDSCAPS_SYSTEMMEMORY;
		ddsd.dwFlags |= DDSD_PIXELFORMAT;
		ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
		ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB | DDPF_PALETTEINDEXED8;
		ddsd.ddpfPixelFormat.dwRGBBitCount = 8;
		res = (*pCreateSurface)(lpdd, &ddsd, lplpdds, pu);
		OutTrace(" 256EmuSub Return %x\n", res);
		return res;
	}

	res = (*pCreateSurface)(lpdd, lpddsd, lplpdds, 0);
	if(res) res = (*pCreateSurfaceOld)(lpdd, lpddsd, lplpdds, 0);
	OutTrace(" Default Return %x\n", res);
	return res;
}

HRESULT WINAPI extGetAttachedSurface(void *lpdds, LPDDSCAPS lpddsc, 
	LPDIRECTDRAWSURFACE *lplpddas)
{
	if(lpdds == lpDDSPrim){
		*lplpddas = lpDDSBack;
		OutTrace("GetAttachedSurface: BackBuffer\n");
		return 0;
	}
	else{
		OutTrace("GetAttachedSurface: Other\n");
		return (*pGetAttachedSurface)(lpdds, lpddsc, lplpddas);
	}
}

HRESULT WINAPI extFlip(LPDIRECTDRAWSURFACE lpdds, LPDIRECTDRAWSURFACE lpddst, DWORD dwflags)
{
	OutTrace("Flip: target = %x src = %x\n", lpdds, lpddst);

	if(lpddst)
		return lpdds->Blt(0, lpddst, 0, DDBLT_WAIT, 0);
	else
		return lpdds->Blt(0, lpDDSBack, 0, DDBLT_WAIT, 0);
}

HRESULT WINAPI extBlt(LPDIRECTDRAWSURFACE lpdds, LPRECT lpdestrect,
	LPDIRECTDRAWSURFACE lpddssrc, LPRECT lpsrcrect, DWORD dwflags, LPDDBLTFX lpddbltfx)
{
	DDSURFACEDESC2 ddsd;
	BYTE *src;
	DWORD *dest;
	long srcpitch, destpitch;
	DWORD x, y, w, h;
	RECT rect, screen;
	POINT p = {0, 0};

	OutTrace("Blt: dest = %x src = %x dwFlags = %x\n",
		lpdds, lpddssrc, dwflags);

	if(lpdds == lpDDSPrim){
		if(lpdestrect) screen = *lpdestrect;
		else GetClientRect(hWnd, &screen);
		ClientToScreen(hWnd, &p);
		OffsetRect(&screen ,p.x, p.y);

		if(dwFlags & EMULATEPAL){
			if(!lpddssrc) return 0;
			(*pBlt)(lpdds, lpdestrect, lpddssrc, lpsrcrect, dwflags, lpddbltfx);
			if(lpdestrect){
				rect = *lpdestrect;
			}
			else{
				rect.left = 0;
				rect.top = 0;
				rect.right = dwWidth;
				rect.bottom = dwHeight;
			}
			w = rect.right - rect.left;
			h = rect.bottom - rect.top;
	
			ddsd.dwSize = (dwVersion < 4) ? sizeof(DDSURFACEDESC) : sizeof(DDSURFACEDESC2);
			ddsd.dwFlags = DDSD_LPSURFACE | DDSD_PITCH;
			if(lpDDSEmu_Back->Lock(0, (DDSURFACEDESC *)&ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_WRITEONLY, 0))
				return 0;
			ddsd.lPitch >>= 2;
			dest = (DWORD *)ddsd.lpSurface;
			dest += rect.top*ddsd.lPitch;
			dest += rect.left;
			destpitch = ddsd.lPitch - w;
			if(lpdds->Lock(0, (DDSURFACEDESC *)&ddsd, DDLOCK_SURFACEMEMORYPTR | DDLOCK_READONLY, 0)){
				lpDDSEmu_Back->Unlock(0);
				return 0;
			}
			src = (BYTE *)ddsd.lpSurface;
			src += rect.top*ddsd.lPitch;
			src += rect.left;
			srcpitch = ddsd.lPitch - w;

			for(y = 0; y < h; y ++){
				for(x = 0; x < w; x ++){
					*(dest ++) = PaletteEntries[*(src ++)];
				}
				dest += destpitch;
				src += srcpitch;
			}
	
			lpdds->Unlock(0);
			lpDDSEmu_Back->Unlock(0);
			p.x = 0; p.y = 0;
			ClientToScreen(hWnd, &p);
			OffsetRect(&rect, p.x, p.y);
			(*pBlt)(lpDDSEmu_Prim, &rect, lpDDSEmu_Back, lpdestrect, DDBLT_WAIT, 0);
			return 0;
		}
		else{
			return (*pBlt)(lpDDSPrim, &screen, lpddssrc, lpsrcrect, dwflags, lpddbltfx);
		}
	}
	else{
		return (*pBlt)(lpdds, lpdestrect, lpddssrc, lpsrcrect, dwflags, lpddbltfx);
	}
	return 0;
}

HRESULT WINAPI extBltFast(LPDIRECTDRAWSURFACE lpdds, DWORD dwx, DWORD dwy, 
	LPDIRECTDRAWSURFACE lpddssrc, LPRECT lpsrcrect, DWORD dwtrans)
{
	RECT r;
	POINT p = {0, 0};
	DWORD flags = 0;
	DDSURFACEDESC2 ddsd;

	OutTrace("BltFast: dest = %x src = %x dwTrans = %x\n",
		lpdds, lpddssrc, dwtrans);

	if(dwtrans & DDBLTFAST_WAIT) flags |= DDBLT_WAIT;
	if(dwtrans & DDBLTFAST_DESTCOLORKEY) flags |= DDBLT_KEYDEST;
	if(dwtrans & DDBLTFAST_SRCCOLORKEY) flags |= DDBLT_KEYSRC;

	r.left = dwx;
	r.top = dwy;
	if(lpsrcrect){
		r.right = r.left + lpsrcrect->right - lpsrcrect->left;
		r.bottom = r.top + lpsrcrect->bottom - lpsrcrect->top;
	}
	else{
		ddsd.dwSize = (dwVersion < 4) ? sizeof(DDSURFACEDESC) : sizeof(DDSURFACEDESC2);
		ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT;
		lpddssrc->GetSurfaceDesc((LPDDSURFACEDESC)&ddsd);
		r.right = r.left + ddsd.dwWidth;
		r.bottom = r.top + ddsd.dwHeight;
	}
	return lpdds->Blt(&r, lpddssrc, lpsrcrect, flags, 0);
}

HRESULT WINAPI extCreatePalette(LPDIRECTDRAW lpdd, DWORD dwflags, LPPALETTEENTRY lpddpa,
	LPDIRECTDRAWPALETTE *lplpddp, IUnknown *pu)
{
	HRESULT res;
	void *tmp;
	int i;

	OutTrace("CreatePalette: dwFlags = %x\n", dwflags);

	if(!(dwFlags & EMULATEPAL)) return (*pCreatePalette)(lpdd, dwflags, lpddpa, lplpddp, pu);

	res = (*pCreatePalette)(lpdd, dwflags & ~DDPCAPS_PRIMARYSURFACE, lpddpa, lplpddp, pu);
	if(res) return res;
	tmp = SetHook((void *)(**(DWORD **)lplpddp + 24), extSetEntries);
	if(tmp) pSetEntries = (SetEntries_Type)tmp;
	if(dwflags & DDPCAPS_PRIMARYSURFACE){
		for(i = 0; i < 256; i ++){
			PaletteEntries[i] =
				(((DWORD)lpddpa[i].peRed) << 16) + (((DWORD)lpddpa[i].peGreen) << 8) + ((DWORD)lpddpa[i].peBlue);
		}
		lpDDP = *lplpddp;
	}
	return 0;
}

HRESULT WINAPI extGetPalette(LPDIRECTDRAWSURFACE lpdds, LPDIRECTDRAWPALETTE *lplpddp)
{
	OutTrace("GetPalette\n");

	if(!(dwFlags & EMULATEPAL) || lpdds != lpDDSPrim) return (*pGetPalette)(lpdds, lplpddp);

	if(!lpDDP) return DDERR_NOPALETTEATTACHED;
	*lplpddp  = lpDDP;
	return 0;
}

HRESULT WINAPI extSetPalette(LPDIRECTDRAWSURFACE lpdds, LPDIRECTDRAWPALETTE lpddp)
{
	int i;
	PALETTEENTRY *tmp;

	OutTrace("SetPalette\n");

	if(!(dwFlags & EMULATEPAL) || lpdds != lpDDSPrim) return (*pSetPalette)(lpdds, lpddp);
	lpDDP = lpddp;
	if(lpddp){
		tmp = (LPPALETTEENTRY)PaletteEntries;
		lpddp->GetEntries(0,0, 256, tmp);
		for(i = 0; i < 256; i ++){
			PaletteEntries[i] =
				(((DWORD)tmp[i].peRed) << 16) + (((DWORD)tmp[i].peGreen) << 8) + ((DWORD)tmp[i].peBlue);
		}
	}
	return 0;
}

HRESULT WINAPI extSetEntries(LPDIRECTDRAWPALETTE lpddp, DWORD dwflags, DWORD dwstart, DWORD dwcount, LPPALETTEENTRY lpentries)
{
	int i;
	HRESULT res;

	OutTrace("SetEntries\n");

	res = (*pSetEntries)(lpddp, dwflags, dwstart, dwcount, lpentries);
	if(!(dwFlags & EMULATEPAL) || lpDDP != lpddp) return res;

	for(i = 0; i < dwcount; i ++){
		PaletteEntries[i + dwstart] =
			(((DWORD)lpentries[i].peRed) << 16) + (((DWORD)lpentries[i].peGreen) << 8) + ((DWORD)lpentries[i].peBlue);
	}
	return 0;
}

HRESULT WINAPI extCreateDevice(void *lpd3d, UINT adapter, D3DDEVTYPE devicetype,
	HWND hfocuswindow, DWORD behaviorflags, D3DPRESENT_PARAMETERS *ppresentparam, void **ppd3dd)
{
	HRESULT res;
	DWORD param[64], *tmp;
	D3DDISPLAYMODE mode;

	if(dwVersion == 9){
		memcpy(param, ppresentparam, 56);
		OutTrace("D3D9::CreateDevice\n");
	}
	else{
		memcpy(param, ppresentparam, 52);
		OutTrace("D3D8::CreateDevice\n");
	}

	hWnd = hfocuswindow;
	dwWidth = param[0];
	dwHeight = param[1];
	AdjustWindowFrame();

	tmp = param;
	OutTrace("  Adapter = %i\n", adapter);
	OutTrace("  DeviceType = %i\n", devicetype);
	OutTrace("  hFocusWindow = 0x%x\n", hfocuswindow);
	OutTrace("  BehaviorFlags = 0x%x\n", behaviorflags);
	OutTrace("    BackBufferWidth = %i\n", *(tmp ++));
	OutTrace("    BackBufferHeight = %i\n", *(tmp ++));
	OutTrace("    BackBufferFormat = %i\n", *(tmp ++));
	OutTrace("    BackBufferCount = %i\n", *(tmp ++));
	OutTrace("    MultiSampleType = %i\n", *(tmp ++));
	if(dwVersion == 9) OutTrace("    MultiSampleQuality = %i\n", *(tmp ++));
	OutTrace("    SwapEffect = 0x%x\n", *(tmp ++));
	OutTrace("    hDeviceWindow = 0x%x\n", *(tmp ++));
	OutTrace("    Windowed = %i\n", *(tmp ++));
	OutTrace("    EnableAutoDepthStencil = %i\n", *(tmp ++));
	OutTrace("    AutoDepthStencilFormat = %i\n", *(tmp ++));
	OutTrace("    Flags = 0x%x\n", *(tmp ++));
	OutTrace("    FullScreen_RefreshRateInHz = %i\n", *(tmp ++));
	OutTrace("    PresentationInterval = 0x%x\n", *(tmp ++));

	((LPDIRECT3D9)lpd3d)->GetAdapterDisplayMode(0, &mode);
	param[2] = mode.Format;
	if(dwVersion == 9){
		param[7] = 0;			//hDeviceWindow
		param[8] = 1;			//Windowed
		param[12] = 0;			//FullScreen_RefreshRateInHz;
		param[13] = D3DPRESENT_INTERVAL_DEFAULT;	//PresentationInterval
	}
	else{
		param[6] = 0;			//hDeviceWindow
		param[7] = 1;			//Windowed
		param[11] = 0;			//FullScreen_RefreshRateInHz;
		param[12] = D3DPRESENT_INTERVAL_DEFAULT;	//PresentationInterval
	}

	res = (*pCreateDevice)(lpd3d, 0, devicetype, hfocuswindow, behaviorflags, param, ppd3dd);
	if(res){
		OutTrace("FAILED! %x\n", res);
		return res;
	}
	OutTrace("SUCCESS!\n");
	return 0;
}

HRESULT WINAPI extDirectInputCreate(HINSTANCE hinst,
	DWORD dwversion, LPDIRECTINPUT *lplpdi, LPUNKNOWN pu)
{
	HRESULT res;
	void *tmp;

	OutTrace("DirectInputCreate: dwVersion = %x\n",
		dwversion);

	res = (*pDirectInputCreate)(hinst, dwversion, lplpdi, pu);
	if(res) return res;
	tmp = SetHook((void *)(**(DWORD **)lplpdi + 12), extDICreateDevice);
	if(tmp) pDICreateDevice = (DICreateDevice_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdi), extQueryInterfaceI);
	if(tmp) pQueryInterfaceI = (QueryInterface_Type)tmp;
	return 0;
}

HRESULT WINAPI extDirectInputCreateEx(HINSTANCE hinst,
	DWORD dwversion, REFIID riidltf, LPVOID *ppvout, LPUNKNOWN pu)
{
	HRESULT res;
	void *tmp;

	OutTrace("DirectInputCreateEx: dwVersion = %x REFIID = %x\n",
		dwversion, riidltf.Data1);

	res = (*pDirectInputCreateEx)(hinst, dwversion, riidltf, ppvout, pu);
	if(res) return res;
	tmp = SetHook((void *)(**(DWORD **)ppvout + 12), extDICreateDevice);
	if(tmp) pDICreateDevice = (DICreateDevice_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)ppvout + 36), extDICreateDeviceEx);
	if(tmp) pDICreateDeviceEx = (DICreateDeviceEx_Type)tmp;
	return 0;
}

HRESULT WINAPI extQueryInterfaceI(void * lpdi, REFIID riid, LPVOID *obp)
{
	HRESULT res;
	void *tmp;

	OutTrace("lpDI->QueryInterface: REFIID = %x\n",
		riid.Data1);

	res = (*pQueryInterfaceI)(lpdi, riid, obp);
	if(res) return res;

	switch(riid.Data1){
	case 0x5944E662:		//DirectInput2A
	case 0x5944E663:		//DirectInput2W
		tmp = SetHook((void *)(**(DWORD **)obp + 12), extDICreateDevice);
		if(tmp) pDICreateDevice = (DICreateDevice_Type)tmp;
		break;
	}
	return 0;
}

HRESULT WINAPI extDirectInput8Create(HINSTANCE hinst,
	DWORD dwversion, REFIID riidltf, LPVOID *ppvout, LPUNKNOWN pu)
{
	HRESULT res;
	void *tmp;

	OutTrace("DirectInput8Create: dwVersion = %x REFIID = %x\n",
		dwversion, riidltf.Data1);

	res = (*pDirectInputCreateEx)(hinst, dwversion, riidltf, ppvout, pu);
	if(res) return res;
	tmp = SetHook((void *)(**(DWORD **)ppvout + 12), extDICreateDevice);
	if(tmp) pDICreateDevice = (DICreateDevice_Type)tmp;
	return 0;
}

HRESULT WINAPI extDICreateDevice(LPDIRECTINPUT lpdi, REFGUID rguid,
	LPDIRECTINPUTDEVICE *lplpdid, LPUNKNOWN pu)
{
	HRESULT res;
	void *tmp;

	OutTrace("lpDI->CreateDevice: REFGUID = %x\n",
		rguid.Data1);

	res = (*pDICreateDevice)(lpdi, rguid, lplpdid, pu);
	if(res) return res;
	tmp = SetHook((void *)(**(DWORD **)lplpdid + 36), extGetDeviceState);
	if(tmp) pGetDeviceState = (GetDeviceState_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdid + 44), extSetDataFormat);
	if(tmp) pSetDataFormat = (SetDataFormat_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)lplpdid + 52), extDISetCooperativeLevel);
	if(tmp) pDISetCooperativeLevel = (DISetCooperativeLevel_Type)tmp;
	return 0;
}

HRESULT WINAPI extDICreateDeviceEx(LPDIRECTINPUT lpdi, REFGUID rguid,
	REFIID riid, LPVOID *pvout, LPUNKNOWN pu)
{
	HRESULT res;
	void *tmp;

	OutTrace("lpDI->CreateDeviceEx: GUID = %x REFIID = %x\n",
		rguid.Data1, riid.Data1);

	res = (*pDICreateDeviceEx)(lpdi, rguid, riid, pvout, pu);
	if(res) return res;
	tmp = SetHook((void *)(**(DWORD **)pvout + 36), extGetDeviceState);
	if(tmp) pGetDeviceState = (GetDeviceState_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)pvout + 44), extSetDataFormat);
	if(tmp) pSetDataFormat = (SetDataFormat_Type)tmp;
	tmp = SetHook((void *)(**(DWORD **)pvout + 52), extDISetCooperativeLevel);
	if(tmp) pDISetCooperativeLevel = (DISetCooperativeLevel_Type)tmp;
	return 0;
}

HRESULT WINAPI extGetDeviceState(LPDIRECTINPUTDEVICE lpdid, DWORD cbData, LPDIMOUSESTATE lpvdata)
{
	HRESULT res;
	POINT p = {0, 0};

	OutTrace("GetDeviceState\n");

	res = (*pGetDeviceState)(lpdid, cbData, lpvdata);
	if(res) return res;
	if(!bDInputAbs) return 0;
	if(cbData == sizeof(DIMOUSESTATE) || cbData == sizeof(DIMOUSESTATE2)){
		ClientToScreen(hWnd, &p);
		lpvdata->lX -= p.x;
		lpvdata->lY -= p.y;
		if(lpvdata->lX < 0) lpvdata->lX = 0;
		if(lpvdata->lX >= dwWidth) lpvdata->lX = dwWidth - 1;
		if(lpvdata->lY < 0) lpvdata->lY = 0;
		if(lpvdata->lY >= dwHeight) lpvdata->lY = dwWidth - 1;
	}
	return 0;
}
	
HRESULT WINAPI extSetDataFormat(LPDIRECTINPUTDEVICE lpdid, LPCDIDATAFORMAT lpdf)
{
	OutTrace("SetDataFormat\n");

	if(lpdf->dwFlags & DIDF_ABSAXIS) bDInputAbs = 1;
	return (*pSetDataFormat)(lpdid, lpdf);
}

HRESULT WINAPI extDISetCooperativeLevel(LPDIRECTINPUTDEVICE lpdid, HWND hwnd, DWORD dwflags)
{
	OutTrace("lpDI->SetCooperativeLevel");

	dwflags = DISCL_NONEXCLUSIVE | DISCL_BACKGROUND;
	return (*pDISetCooperativeLevel)(lpdid, hwnd, dwflags);
}

int HookDirectX(int version, int flags)
{
	HINSTANCE hinst;
	LPDIRECTDRAW lpdd;
	LPDIRECTINPUT lpdi;
	void *tmp;
	const GUID dd7 = {0x15e65ec0,0x3b9c,0x11d2,0xb9,0x2f,0x00,0x60,0x97,0x97,0xea,0x5b};
	const GUID di7 = {0x9A4CB684,0x236D,0x11D3,0x8E,0x9D,0x00,0xC0,0x4F,0x68,0x44,0xAE};
	const GUID di8 = {0xBF798030,0x483A,0x4DA2,0xAA,0x99,0x5D,0x64,0xED,0x36,0x97,0x00};
	dwFlags = flags;
	if(dwFlags & EMULATEPAL){
		tmp = HookAPI("gdi32.dll", "GetDeviceCaps", extGetDeviceCaps);
		if(tmp) pGetDeviceCaps = (GetDeviceCaps_Type)tmp;
	}
	
	if(dwFlags & MODIFYMOUSE){
		tmp = HookAPI("user32.dll", "GetCursorPos", extGetCursorPos);
		if(tmp) pGetCursorPos = (GetCursorPos_Type)tmp;
	}

	if(dwFlags & HOOKDI){
		tmp = HookAPI("dinput.dll", "DirectInputCreateA", extDirectInputCreate);
		if(tmp) pDirectInputCreate = (DirectInputCreate_Type)tmp;
		tmp = HookAPI("dinput.dll", "DirectInputCreateW", extDirectInputCreate);
		if(tmp) pDirectInputCreate = (DirectInputCreate_Type)tmp;
		tmp = HookAPI("dinput.dll", "DirectInputCreateEx", extDirectInputCreateEx);
		if(tmp) pDirectInputCreateEx = (DirectInputCreateEx_Type)tmp;
		tmp = HookAPI("dinput8.dll", "DirectInput8Create", extDirectInput8Create);
		if(tmp) pDirectInputCreateEx = (DirectInputCreateEx_Type)tmp;
		if(!pDirectInputCreate && !pDirectInputCreateEx){
			if(version < 8){
				hinst = LoadLibrary("dinput.dll");
				pDirectInputCreate =
					(DirectInputCreate_Type)GetProcAddress(hinst, "DirectInputCreateA");
				if(pDirectInputCreate)
					if(!extDirectInputCreate(GetModuleHandle(0), DIRECTINPUT_VERSION,
						&lpdi, 0)) lpdi->Release();
				pDirectInputCreateEx =
					(DirectInputCreateEx_Type)GetProcAddress(hinst, "DirectInputCreateEx");
				if(pDirectInputCreateEx)
					if(!extDirectInputCreateEx(GetModuleHandle(0), DIRECTINPUT_VERSION,
						di7, (void **)&lpdi, 0)) lpdi->Release();
			}
			else{
				hinst = LoadLibrary("dinput8.dll");
				pDirectInputCreateEx =
					(DirectInputCreateEx_Type)GetProcAddress(hinst, "DirectInput8Create");
				if(pDirectInputCreateEx)
					if(!extDirectInputCreateEx(GetModuleHandle(0), DIRECTINPUT_VERSION,
						di8, (void **)&lpdi, 0)) lpdi->Release();
			}
		}
	}
	switch(version){
	case 0:
		tmp = HookAPI("ddraw.dll", "DirectDrawCreate", extDirectDrawCreate);
		if(tmp) pDirectDrawCreate = (DirectDrawCreate_Type)tmp;
		tmp = HookAPI("ddraw.dll", "DirectDrawCreateEx", extDirectDrawCreateEx);
		if(tmp) pDirectDrawCreateEx = (DirectDrawCreateEx_Type)tmp;
		tmp = HookAPI("d3d8.dll", "Direct3DCreate8", extDirect3DCreate8);
		if(tmp) pDirect3DCreate8 = (Direct3DCreate8_Type)tmp;
		tmp = HookAPI("d3d9.dll", "Direct3DCreate9", extDirect3DCreate9);
		if(tmp) pDirect3DCreate9 = (Direct3DCreate9_Type)tmp;
		if(!pDirectDrawCreate && !pDirect3DCreate8 && !pDirect3DCreate9)
			OutTrace("Can't Hook CreateFunctions.\n");
		break;
	case 1:
	case 2:
	case 3:
	case 5:
	case 6:
		hinst = LoadLibrary("ddraw.dll");
		pDirectDrawCreate =
			(DirectDrawCreate_Type)GetProcAddress(hinst, "DirectDrawCreate");
		if(pDirectDrawCreate)
			if(!extDirectDrawCreate(0, &lpdd, 0)) lpdd->Release();
		break;
	case 7:
		hinst = LoadLibrary("ddraw.dll");
		pDirectDrawCreateEx =
			(DirectDrawCreateEx_Type)GetProcAddress(hinst, "DirectDrawCreateEx");
		if(pDirectDrawCreateEx)
			if(!extDirectDrawCreateEx(0, &lpdd, dd7, 0)) lpdd->Release();
		break;
	case 8:
		hinst = LoadLibrary("d3d8.dll");
		pDirect3DCreate8 =
			(Direct3DCreate8_Type)GetProcAddress(hinst, "Direct3DCreate8");
		if(pDirect3DCreate8){
			lpdd = (LPDIRECTDRAW)extDirect3DCreate8(220);
			if(lpdd) lpdd->Release();
		}
		break;
	case 9:
		hinst = LoadLibrary("d3d9.dll");
		pDirect3DCreate9 =
			(Direct3DCreate9_Type)GetProcAddress(hinst, "Direct3DCreate9");
		if(pDirect3DCreate9){
			lpdd = (LPDIRECTDRAW)extDirect3DCreate9(31);
			if(lpdd) lpdd->Release();
		}
	break;
	}

	return 0;
}
